#pragma once

#include <objmodel.h>
#include "button.h"
#include "scopekey.h"
#include "togglebutton.h"

class CGraphWndToolbar : public Gtk::HBox, public IGraphWndToolbar
{
public:
  CGraphWndToolbar(IGraphWnd* pParent, unsigned int index);
  virtual ~CGraphWndToolbar();
  // IGraphWndToolbar interface
  void deviceChanged();
  control_handle_t getNativeControl() { return *this; }
  IGraphWnd* getParent() const { return m_pParent; }
  bool_t getPaused() const { return m_bPaused; }
  void numGraphWndChanged();
  void numTraceChanged();
  void setIndex(unsigned int index);

protected:
  IGraphWnd* m_pParent;
  unsigned int m_index;
  bool_t m_bPaused;

protected:
  Gtk::Label m_labelCtl;
  ::CButton m_ampCtl;
  ::CButton m_boolCtl;
  ::CButton m_closeCtl;
  ::CToggleButton m_pauseCtl;
  ::CButton m_plusCtl;
  ::CButton m_tempCtl;
  ::CButton m_voltCtl;
  Gtk::Label m_keyCtl;
  Gtk::HBox m_hBoxCtl;
  CScopeKey m_keyTipCtl;

protected:
  void addSensors(ADMXRC3_DATA_TYPE datatype);
  void addSensors(ADMXRC3_UNIT_TYPE unit);
  void adjustScale(float value);
  void onButtonAmp();
  void onButtonBool();
  void onButtonClose();
  void onButtonPauseToggle();
  void onButtonPlus();
  void onButtonTemp();
  void onButtonVolt();
  bool onShowKey(int x, int y, bool keyboard_tooltip, const Glib::RefPtr<Gtk::Tooltip>& tooltip);
};
