#pragma once

#include <assert.h>
#include <stdint.h>
#include <gtkmm.h>

#define _T(x) x

#define RGB(r, g, b) (((r) << 0) | ((g) << 8) | ((b) << 16))
#define RED(x) (((x) >> 0) & 0xff)
#define GREEN(x) (((x) >> 8) & 0xff)
#define BLUE(x) (((x) >> 16) & 0xff)

#define ASSERT(x) do { if (!(x)) { throw new std::logic_error(#x); } } while (0)

using std::hex;
using std::dec;
using std::uppercase;
using std::nouppercase;
using std::fixed;

#define HEX hex << uppercase
#define DEC dec << nouppercase

typedef int bool_t;
typedef uint32_t color_t;
typedef char TCHAR;
typedef Gtk::Widget& control_handle_t;
typedef Gtk::Window& window_handle_t;
